<template>
  <div class="container-mid">
    <div v-if="entity">
      <span class="edit-link float-right">
        <button
          v-if="$store.getters['auth/isAdmin'] && !$store.getters['auth/isShapeshifting'] && $store.getters['auth/user']._id != entity._id"
          class="btn btn-outline-secondary mr-1"
          @click="shapeshift"
        >
          <div class="d-flex align-items-center">
            <app-icon size="s" icon="shapeshift" class="mr-1" />
            <span>Shapeshift</span>
          </div>
        </button>
        <router-link :to="`/users/edit/${entity._id}`" class="btn btn-outline-primary">Edit</router-link>
      </span>
      <h1>
        {{entity.username}}
        <app-icon v-if="isAdmin" class="mr-2" icon="admin" style="position: relative; top: -2px" />
      </h1>

      <h3>Details</h3>
      <ul class="list-group">
        <li class="list-group-item">
          <strong>Email</strong>
          <br />
          {{entity.email}}
        </li>
      </ul>
      <h3 class="mt-2">Permissions</h3>
      <ul class="list-group">
        <li
          v-for="permission in entity.permissions"
          :key="permission"
          class="list-group-item"
        >{{permission}}</li>
      </ul>
    </div>
    <app-feedback v-if="status" @closed="status = ''">{{status}}</app-feedback>
  </div>
</template>

<script>
import api from "@/services/api.service";

export default {
  name: "User",
  data() {
    return {
      status: "",
      entity: null
    };
  },
  methods: {
    async getEntity() {
      try {
        const id = this.$route.params.id;
        const { data } = await api.get(`/users/${id}`);
        this.entity = data;
        console.log(this.entity);
      } catch (e) {
        this.status = e.response.data;
      }
    },
    shapeshift() {
      this.$store.dispatch("auth/enterShapeshift", this.entity._id);
    }
  },
  computed: {
    isAdmin() {
      return this.entity.permissions.includes("admin");
    }
  },
  created() {
    this.getEntity();
  }
};
</script>

<style scoped>
img {
  max-width: 100%;
}
</style>
